import _ from 'underscore';
import { isVoid, isJquery, toJquery } from './src/type-system';
import { guid, newId } from './src/guid';
import { isKeyTextInput, isKeyAlphaNumeric, containsArabic, kebab_case_to_camelCase } from './src/text';
import { callSafe } from './src/func';
import { spinLock } from './src/spin-lock';
import { render } from './src/templating';
import { Culture, Direction, Cultures, XsrfHeaderName, XsrfValue, GoogletMapApiKey, GoogleAnalyticsId, Calendar } from './src/conf';
import { dateTimeFormats } from "./src/dateTimeFormats";
import { calendars } from "./src/calendars";
import { dat } from "./src/dat";
import { registerXsrfHeaderInAjaxPost, createUrl, createAjaxOptions, send, sendGet, sendPost } from './src/ajax';
window._ = _;
export {
    isVoid,
    isJquery,
    toJquery,
    guid,
    newId,
    isKeyTextInput,
    isKeyAlphaNumeric,
    containsArabic,
    kebab_case_to_camelCase,
    callSafe,
    spinLock,
    render,
    dateTimeFormats,
    calendars,
    dat,
    registerXsrfHeaderInAjaxPost,
    createUrl,
    createAjaxOptions,
    send,
    sendGet,
    sendPost
};
_.isVoid = isVoid;
_.isJquery = isJquery;
_.toJquery = toJquery;
_.callSafe = callSafe;
_.guid = guid;
_.newId = newId;
_.kebab_case_to_camelCase = kebab_case_to_camelCase;
_.containsArabic = containsArabic;
_.isKeyAlphaNumeric = isKeyAlphaNumeric;
_.isKeyTextInput = isKeyTextInput;
_.spinLock = spinLock;
_.render = render;
_.culture = new Culture().culture;
_.dir = new Direction().dir;
_.cultures = new Cultures().cultures;
_.xsrfHeaderName = new XsrfHeaderName().xsrfHeaderName;
_.xsrfValue = new XsrfValue().xsrfValue;
_.googletMapApiKey = new GoogletMapApiKey().googletMapApiKey;
_.googleAnalyticsId = new GoogleAnalyticsId().googleAnalyticsId;
_.calendar = new Calendar().calendar;
_.newDat = (calendar, year, month, day, hour = 0, minute = 0, second = 0, millisecond = 0) => {
    var res = new dat(calendar);
    return res.year(year).month(month).day(day).hour(hour).minute(minute).second(second).millisecond(millisecond);
};
_.dateTimeFormats = dateTimeFormats;
_.calendars = calendars;
_.dat = dat;
_.registerXsrfHeaderInAjaxPost = registerXsrfHeaderInAjaxPost;
_.createUrl = createUrl;
_.createAjaxOptions = createAjaxOptions;
_.send = send;
_.sendGet = sendGet;
_.sendPost = sendPost;