import _ from 'underscore';
import { isVoid } from './type-system';
import { calendars } from './calendars';

export function Culture() {
    this.x = 'fa';
    this.culture = (culture) => {
        if (!isVoid(culture)) {
            this.x = culture;
        }
        return this.x;
    };
};

export function Cultures() {
    this.x = [];
    this.cultures = (cultures) => {
        if (!isVoid(cultures)) {
            this.x.splice(0, this.x.length);
            _.each(cultures, a => {
                this.x.push(a);
            });
        }
        return this.x;
    };
};

export function Direction() {
    this.dir = (culture) => {
        var c = _.culture();
        if (!isVoid(culture)) {
            c = culture;
        }
        if (c === "fa" || c === "ur" || c === "af" || c === "ar") {
            return "rtl";
        }
        return "ltr";
    };
};

export function Calendar() {
    this.calendar = () => {
        var c = _.culture();
        if (c === "fa") {
            return calendars.jalaali;
        }
        if (c === "ar") {
            return calendars.hijri;
        }
        return calendars.gregorian;
    };
};

export function XsrfHeaderName() {
    this.x = 'X-XSRF-TOKEN';
    this.xsrfHeaderName = (xsrfHeaderName) => {
        if (!isVoid(xsrfHeaderName)) {
            this.x = xsrfHeaderName;
        }
        return this.x;
    };
};

export function XsrfValue() {
    this.x = '';
    this.xsrfValue = (containerSelector, tagName = '__RequestVerificationToken') => {
        if (!isVoid(containerSelector)) {
            this.x = $(containerSelector).find(`[name=${tagName}]`).val();
        }
        return this.x;
    };
};

export function GoogletMapApiKey() {
    this.x = '';
    this.googletMapApiKey = (apiKey) => {
        if (!isVoid(apiKey)) {
            this.x = apiKey;
        }
        return this.x;
    };
};

export function GoogleAnalyticsId() {
    this.x = '';
    this.googleAnalyticsId = (gaid) => {
        if (!isVoid(gaid)) {
            this.x = gaid;
        }
        return this.x;
    };
};