import { callSafe } from './func';
export function spinLock(locked, unlocked) {
    this.locked = false;
    /**
     * locks
     */
    this.lock = () => {
        this.locked = true;
        callSafe(locked);
    };
    /**
     * unlocks
     */
    this.unlock = () => {
        this.locked = false;
        callSafe(unlocked);
    };
    /**
     * checks if is locked
     * @returns true or false
     */
    this.isLocked = () => {
        return this.locked;
    };
    /**
     * waits for an unlock to happen asynchronously
     */
    this.waitForLock = (onUnlocked) => {
        if (this.locked === false) {
            setTimeout(this.waitForLock, 100, fn);
        } else {
            callSafe(onUnlocked);
        }
    };
};